//
//  SelfieInstructionsViewController.swift
//  Pods
//
//  Created by Juan Carlos Pérez on 1/30/19.
//  Copyright (c) 2019 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit
import AVKit

protocol SelfieInstructionsDisplayLogic: class
{
    func displaySomething(viewModel: SelfieInstructions.Something.ViewModel)
    func  showSelfiePreview(imgPhoto:UIImage)
    func takeSelfieAgain()
}

class SelfieInstructionsViewController: UIViewController, SelfieInstructionsDisplayLogic
{
    
    @IBOutlet weak var lblTittle: UILabel!
    
    var interactor: SelfieInstructionsBusinessLogic?
    var router: (NSObjectProtocol & SelfieInstructionsRoutingLogic & SelfieInstructionsDataPassing)?
    
    fileprivate var popupChooseCameraViewController : PopupChooseCameraViewController!

  // MARK: Object lifecycle
  
  override init(nibName nibNameOrNil: String?, bundle nibBundleOrNil: Bundle?)
  {
    super.init(nibName: nibNameOrNil, bundle: nibBundleOrNil)
    setup()
  }
  
  required init?(coder aDecoder: NSCoder)
  {
    super.init(coder: aDecoder)
    setup()
  }
  
  // MARK: Setup
  
  private func setup()
  {
    let viewController = self
    let interactor = SelfieInstructionsInteractor()
    let presenter = SelfieInstructionsPresenter()
    let router = SelfieInstructionsRouter()
    viewController.interactor = interactor
    viewController.router = router
    interactor.presenter = presenter
    presenter.viewController = viewController
    router.viewController = viewController
    router.dataStore = interactor
  }
  
  // MARK: Routing
  
  override func prepare(for segue: UIStoryboardSegue, sender: Any?)
  {
    if let scene = segue.identifier {
      let selector = NSSelectorFromString("routeTo\(scene)WithSegue:")
      if let router = router, router.responds(to: selector) {
        router.perform(selector, with: segue)
      }
    }
  }
  
  // MARK: View lifecycle
  
  override func viewDidLoad()
  {
    super.viewDidLoad()
    doSomething()
    
  }
  
  // MARK: Do something
  
  //@IBOutlet weak var nameTextField: UITextField!
  
  func doSomething()
  {
    let request = SelfieInstructions.Something.Request()
    interactor?.doSomething(request: request)
  }
  
  func displaySomething(viewModel: SelfieInstructions.Something.ViewModel)
  {
    //nameTextField.text = viewModel.name
  }
    
    
    @IBAction func captureAction(_ sender: Any) {
        
        guard let _ = AVCaptureDevice.devices().filter({ $0.position == .front }).first else {
                //fatalError("No front facing camera found")
                router?.routeToTakeSelfie(segue: nil)
                return
        }
        
        
        let storyboard = UIStoryboard(name: "Selfie", bundle: Utils.getSDKBundle())
        self.popupChooseCameraViewController = storyboard.instantiateViewController(withIdentifier: "PopupChooseCameraViewControllerId") as? PopupChooseCameraViewController
        self.popupChooseCameraViewController.delegate = self
        self.popupChooseCameraViewController.showInView(self)
        //router?.routeToTakeSelfie(segue: nil)
    }
    
    
    func showSelfiePreview(imgPhoto:UIImage) {
        interactor?.doRegisterPhoto(imgPhoto: imgPhoto)
        router?.routeToShowPreview(segue: nil)
    }
    
    func takeSelfieAgain(){
        router?.routeToTakeSelfie(segue: nil)
    }
    
    
}

extension SelfieInstructionsViewController : PopupChooseCameraViewControllerDelegate{
    func doneShowPopup(frontCamera: Bool) {
        self.interactor?.setCameraPreferences(showFrontCamera: frontCamera)
        router?.routeToTakeSelfie(segue: nil)
    }
}
